/*
 *  sample_bipartite_external_field.cpp
 *  
 *
 *  Created by Damian Farnell on 11/04/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

double usr_angle(int bonds, int term13, double *alpha, int numalpha)
{
  // add your model specifique parameter here! 
  // BIPARTITE AFS: linear chain, square and cubic lattice cases 
	
  // Heisenberg AFs on bipartite lattices. 
  //  tdelta * H1 + H2 + H3 + ...

  double returnValue;
	
  returnValue=0.0;
	
  if (bonds == 2) {

    if (term13==1) returnValue=      -cos(2*alpha[0]);
    if (term13==2) returnValue=  -0.5*sin(2*alpha[0]);
    if (term13==3) returnValue=  -0.5*sin(2*alpha[0]);
    if (term13==4) returnValue=   0.5*sin(2*alpha[0]);
    if (term13==5) returnValue=   0.5*sin(2*alpha[0]);
    if (term13==6) returnValue=  0.25*(1.0-cos(2*alpha[0]));
    if (term13==7) returnValue=  0.25*(1.0-cos(2*alpha[0]));
    if (term13==8) returnValue= -0.25*(1.0+cos(2*alpha[0]));
    if (term13==9) returnValue= -0.25*(1.0+cos(2*alpha[0]));
	  
  } else if (bonds == 1) {
	  
    if (term13==10) returnValue=     sin(alpha[0]);
    if (term13==11) returnValue= 0.5*cos(alpha[0]);
    if (term13==13) returnValue= 0.5*cos(alpha[0]);

  } 
	
  return returnValue;
}

/*
 *  sample_bipartite_external_field_expectation.cpp
 *  
 *
 *  Created by Damian Farnell on 11/04/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

double usr_exp_angle(int expect, int term13, double *alpha, int numalpha)
{
  // add your model specifique parameter here! 
	
  // BIPARTITE AFS: linear chain, sqare and cubic lattice cases 
	
  // Heisenberg AFs on bipartite lattices. 
  //  tdelta * H1 + H2 + H3 + ...

  double returnValue;
	
  returnValue=0.0;
	
  if (expect == 1) {
	  
    if (term13==10) returnValue=     sin(alpha[0]);
    if (term13==11) returnValue= 0.5*cos(alpha[0]);
    if (term13==13) returnValue= 0.5*cos(alpha[0]);

   } 
	
   return returnValue;
}
